Archivserver

Archivserver

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com

Der zenon Archivserver dient der Aufzeichnung historischer Daten. Die Daten können zyklisch, ereignisgesteuert oder bei Wertänderung aufgezeichnet werden:

  • Bei der zyklischen Aufzeichnung definieren Sie einen bestimmten Zyklus (z. B. alle fünf Minuten). In diesem Zyklus werden die Werte der zugeordneten Variablen in das Archiv geschrieben.
  • Für die ereignisgesteuerte Aufzeichnung legen Sie eine Bit-Variable an. Immer wenn diese Variable auf den Wert 1 gesetzt wird, werden die Werte der zugeordneten Variablen in das Archiv geschrieben.
  • Bei der Aufzeichnung bei Wertänderung werden die Werte der zugeordneten Variablen bei jeder Wertänderung in das Archiv geschrieben.

Die Rohdaten eines solchen Basisarchivs können dann in einem Verdichtungsarchiv verdichtet werden.

Der Archivserver befindet sich im Projektmanager.

Noch in diesem Kapitel

Erstellen eines Basisarchivs

Das Bild Archiv-Nachbearbeitung

Archive in der Runtime

Erstellen eines Verdichtungsarchivs

Das Verdichtungsarchiv in der Runtime

Chargenarchivierung

Chargenarchive in der Runtime

Auslagerung in SQL-Datenbank


Erstellen eines Basisarchivs

Archivserver -> Erstellen eines Basisarchivs

Als Grundlage für die Beispiele in diesem Tutorial wird das Projekt verwendet, das wir im Basis-Tutorial erstellt haben.

Wir erstellen nun ein Basisarchiv, das die Werte unserer Motoren zyklisch alle zehn Sekunden aufzeichnet.

  • Indem Sie mit der rechten Maustaste auf den Eintrag Archivserver klicken, öffnen Sie ein Kontextmenü.

  • Wählen Sie den Eintrag Archiv neu.
  • Folgende Dialogbox öffnet sich.

Noch in diesem Kapitel

Eigenschaften des Basisarchivs

Laufzeitverhalten des Basisarchivs

Aufzeichnungsart im Basisarchiv

Speicherverhalten des Basisarchivs

Optionen des Basisarchivs


Eigenschaften des Basisarchivs

Archivserver -> Erstellen eines Basisarchivs -> Eigenschaften des Basisarchivs

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com

  • Tragen Sie die Bezeichnung und den Namen für unser Archiv BA - BASISARCHIV ein, wie in der obigen Abbildung dargestellt.
  • Über das Kontext-Menü und den Befehl Variable hinzufügen gelangen Sie in die Variablenliste.
  • Wählen Sie alle Variablen für unsere vier Motoren aus und verlassen Sie die Variablenliste mit OK.

info Info

Sie können entweder die einzelnen Variablen doppelklicken um sie in den unteren Teil der Dialogbox zu bekommen oder Sie wählen die Variablen aus und drücken Sie den Button Hinzufügen.

So sollte die Dialogbox nun aussehen, nachdem Sie die Variablenliste durch einen Klick auf das + davor geöffnet haben.


Laufzeitverhalten des Basisarchivs

Archivserver -> Erstellen eines Basisarchivs -> Laufzeitverhalten des Basisarchivs

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com

Auf der zweiten Seite der Dialogbox stellen wir nun das Laufzeitverhalten unseres Basisarchivs ein.

  • Setzen Sie Starten und Beenden auf Bei Start und Ende der Runtime , damit wir das Starten und Beenden des Archivs nicht von Hand (d.h. über Funktionen) definieren müssen. Damit erübrigt sich auch eine Einstellung in der Sektion Funktion ausführen bei.
  • Der Beginn des Abtast- und Speicherzyklus sollte eine gerade Uhrzeit und ein Datum in der Vergangenheit beinhalten, damit die Datenaufzeichnung gleich beim nächsten Start der Runtime beginnt.


Aufzeichnungsart im Basisarchiv

Archivserver -> Erstellen eines Basisarchivs -> Aufzeichnungsart im Basisarchiv

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com

Die dritte Seite der Dialogbox erlaubt uns die Einstellung zur Aufzeichnungsart.

  • Wählen Sie die zyklische Abtastung.
  • Geben sie einen Zyklus von 10 Sekunden ein.

Mit diesen Einstellungen werden alle zehn Sekunden die aktuellen Werte der verknüpften Variablen mit den entsprechenden Zeitstempeln in das Archiv eingetragen.


Speicherverhalten des Basisarchivs

Archivserver -> Erstellen eines Basisarchivs -> Speicherverhalten des Basisarchivs

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com

Auf der vierten Seite dieser Dialogbox stellen wir nun ein, wie die Archivdateien gespeichert werden sollten.

  • Wir speichern unser Basisarchiv in der Internen Datenbank (d.h. im zenon Format). So können wir die Archiveinträge später in anderen Modulen (etwa Report Generator oder Erweitertes Trend Modul ) weiterverwenden.
  • Stellen Sie den Zyklus auf zwei Minuten.

Wir bekommen damit für jeweils zwei Minuten eine eigene Datei. Da wir die Abtastung auf zehn Sekunden gesetzt haben, werden wir für jede verknüpfte Variable zwölf Werte in einer Archiv-Datei bekommen.

info Info

Grundsätzlich hat diese Einstellung wenig Auswirkung, wenn Sie nur mit Basisarchiven arbeiten. Sie greifen auf Archivdaten ohnehin immer mit Filtern (etwa Zeitfiltern) zu und zenon kümmert sich automatisch darum die richtigen Dateien zu öffnen.

Allerdings legen Sie hier schon den Zyklus für ein Verdichtungsarchiv fest!

  • In der Sektion Auslagerung stellen Sie ein, dass unsere Archive nicht ausgelagert werden sollen. Die Basisarchivdateien sollen einen Tag aufbewahrt werden.

info Info

zenon schreibt die Archive in eine Art Ringspeicher, den wir hier definieren. Damit soll sichergestellt werden, dass die Festplatte nicht überlaufen kann. Wenn Sie die Archive auslagern (d.h. bevor sie gelöscht werden, werden sie als dBase- oder Text-Dateien gespeichert), müssen Sie selbst darauf achten, dass die Festplatte nicht zu voll wird.


Optionen des Basisarchivs

Archivserver -> Erstellen eines Basisarchivs -> Optionen des Basisarchivs

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com

Auf der fünften und letzten Seite dieser Dialogbox stellen wir nun ein, wie verschiedene Werte in Verdichtungsarchiven behandelt werden sollten.

  • Schalten Sie die Option Berechnungen in Verdichtungsarchiven bei Status aktiv. Nun werden nicht mehr automatisch alle Werte des Basisarchivs zur Berechnung in Verdichtungsarchiven herangezogen, sondern nur mehr die von Ihnen ausgewählten.
  • Schalten Sie die Option INVALID-Bit (Ersatzwert) inaktiv, damit Ersatzwerte nicht mehr für die Berechnungen in Verdichtungsarchiven verwendet werden.
  • Nun können Sie die Einstellungen mit OK bestätigen und die Dialogbox verlassen.


Das Bild Archiv-Nachbearbeitung

Archivserver -> Das Bild Archiv-Nachbearbeitung

Um die archivierten Daten in der Runtime anzeigen zu können, benötigen wir ein eigenes Bild.

  • Legen Sie ein neues Bild mit dem Namen Archiv an.
  • Wählen Sie unter Bildtyp den Eintrag Archiv-Nachbearbeitung .
  • Wählen Sie die Schablone Prozessbild.

Mit dem Erscheinen des neuen, leeren Bildes erhält der Menüpunkt Kontrollelemente spezielle Einträge. Diese Kontrollelemente sind für die Bedienung des Archiv-Bildes vordefinierte dynamische Elemente.

  • Setzen Sie die gewünschten Kontrollelemente in Ihr Bild und speichern Sie es ab.

info Info

Mit dem Menüpunkt Vorlage einfügen... im Menü Kontrollelemente haben Sie mit nur einem Mausklick ein Standard-Archiv-Bild mit allen Bedienelementen erstellt. Dieses können Sie natürlich auch nachträglich ändern.

Noch in diesem Kapitel

Bildumschaltung - ARCHIV


Bildumschaltung - ARCHIV

Archivserver -> Das Bild Archiv-Nachbearbeitung -> Bildumschaltung - ARCHIV

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com

Die Parametrierung des dargestellten Inhalts der Liste erfolgt nicht im Bild selbst sondern über die Filterbedingungen der Bildumschaltung-Funktion, die das Bild dann aufrufen wird. Dies bietet Ihnen die Möglichkeit mit verschiedenen Funktionen immer wieder auf dasselbe Bild zuzugreifen und sich aber jeweils anders gefilterte Listen darstellen zu lassen.

  • Erstellen Sie eine Funktion Bildumschaltung und wählen Sie das Bild Archiv aus.
  • Wählen Sie das Archiv BA - BASISARCHIV aus.

  • Betätigen Sie jetzt den Button Filter.
  • In der nun erscheinenden Filter-Dialogbox schränken Sie die anzuzeigenden Daten entsprechend Ihren Bedürfnissen ein.

Die folgenden Filtermöglichkeiten stehen Ihnen hier zur Verfügung:

Status | Sie können die Darstellungen auf folgende Status beschränken: MAN_VAL: von Hand editierte Werte SPONT: Werte aus der Steuerung INVALID: von zenon gesetzte Ersatzwerte
Variable | Wählen Sie aus, welche Variablen mit ihren archivierten Werten dargestellt werden sollten.
Wert | Hier können Sie den Wertebereich für die darzustellenden Archiveinträge einschränken.

Auf der zweiten Seite der Dialogbox stellen wir nun die Zeitfilter ein.

Die Einstellungen beim Zeitfilter teilen sich in zwei Gruppen:

Zeit Format

Hier stellen Sie die anzuzeigende Zeit ein.

Filter Type

Hier definieren Sie, wie die Filterbox zur Runtime aussehen soll, um dem Endbenutzer die Bedienung zu erleichtern.

Sobald Sie eine andere Einstellung als Default wählen, wird in der Runtime anstatt der Filterbox aus dem Editor ein Übersichtskalender bzw. eine Liste existierender Chargen angeboten.
  • Öffnen Sie das Bild BL-Start und fügen Sie einen neuen Button mit der Beschriftung Archive hinzu.
  • Verknüpfen Sie die eben erstellte Funktion mit diesem Button.


Archive in der Runtime

Archivserver -> Archive in der Runtime

Nun ist es an der Zeit, dass wir uns das neue Archiv in der Runtime ansehen.

info Info

Wenn Ihre Runtime schon läuft, müssen Sie sie beenden und neu starten. Ein Nachladen reicht hier nicht, da wir in der Archiv-Definition eingestellt haben, dass das Archiv mit der Runtime gestartet und beendet werden soll. Beim reinen Nachladen würde das Archiv also einfach nicht gestartet werden.
  • Starten Sie die Runtime.
  • Öffnen Sie den Windows Explorer.
  • Öffnen Sie das Verzeichnis C:/Beispiel/PROJEKT1/<Name Ihres Rechners>/PROJEKT1.

In diesem Verzeichnis werden die Archiv-Dateien standardmäßig gespeichert.

Zum einen finden Sie hier eine Datei BA.ARX. Das ist die Datei, in die gerade Werte geschrieben werden. Wir nennen diese Datei das Alpha-Archiv. Bei unserem Archiv wird diese Datei alle zwei Minuten geschlossen, umbenannt und eine neue, leere Datei dieses Namens erstellt.

Die historischen Dateien haben dann einen Namen der sich aus der Kurzbezeichnung des Archivs, dem Datum und der Uhrzeit zusammensetzt.

info Info

Bei der Uhrzeit im Dateinamen wird Greenwich Mean Time verwendet.

info Info

Grundsätzlich müssen Sie die Dateinamen nicht erkennen können. Sie greifen auf Archivdaten ohnehin immer mit Filtern (etwa Zeitfiltern) zu und zenon kümmert sich automatisch darum die richtigen Dateien zu öffnen.

Allerdings können Sie beim Export von Archiven die Dateinamen automatisch generieren lassen, wobei wiederum diese Namenskonvention verwendet wird.

Wechseln Sie in die Runtime.

  • Öffnen Sie das Archiv-Bild.

info Info

Sollten manche Spalten zu schmal sein, klicken Sie einfach den Button Diagramfenster... und ändern Sie in der Dialogbox die entsprechende Spaltenbreite.

Mit den Standard-Einstellungen erlaubt Ihnen zenon Archiv-Einträge von Hand zu ändern.

  • Doppelklicken Sie einen Archiv-Eintrag.

Die folgende Dialogbox öffnet sich.

  • Ändern Sie den Wert auf 999999.
  • Bestätigen Sie die Änderung mit OK.

Dieser Wert liegt deutlich ausserhalb des Wertebereichs der Variable, dennoch wird er von zenon akzeptiert. Der Wertbereich der verknüpften Variable wird hier also nicht überprüft.

Der geänderte Eintrag hat nun den neuen Wert und erhält den Status MAN_VAL. Zugleich wird die Zeile blau dargestellt.

Allerdings ist die Änderung jetzt noch nicht in der entsprechenden Archiv-Datei verspeichert. Dies wird durch die rote Titelleiste angezeigt.

  • Klicken Sie den Button Speichern.

Jetzt erst wird der neue Wert in der Archiv-Datei gespeichert und die Titelleiste ist wieder hellblau.

info Info

Sie können eine Änderung rückgängig machen, wenn Sie vor dem Speichern versuchen ein anderes Bild der gleichen Schablone zu öffnen. Dann werden Sie gefragt, ob Sie die Änderungen speichern wollen.

Wenn Sie diese Abfrage mit Nein beantworten, werden die Änderungen nicht in der entsprechenden Archiv-Datei gespeichert.

Noch in diesem Kapitel

Online-Filter


Online-Filter

Archivserver -> Archive in der Runtime -> Online-Filter

Sie haben nicht nur die Möglichkeit im Editor Filter fix zu definieren. zenon erlaubt es auch Filter in der Runtime aufzuschalten. Dazu werden wir nun unsere Funktion für das Aufschalten des Archiv-Bildes bearbeiten.

  • Wechseln Sie mit Alt-Tab zurück in den Editor.
  • Wählen Sie die Funktion Bildumschaltung - Archiv BA aus.
  • Im Eigenschaften-Fenster klicken Sie bei Allgemein/Parameter in die rechte Spalte.
  • Bestätigen Sie das Archiv-Bild mit OK.
  • Klicken Sie auf den Button Filter.
  • Aktivieren Sie rechts unten die Option mit Filterdialog.
  • Deaktivieren Sie rechts unten die Option Alle Einträge.

Würden Sie die Dialogbox jetzt mit OK schließen, bekämen Sie in der Runtime genau die gleiche Filterbox, wie Sie sie aus dem Editor kennen. Allerdings bietet Ihnen zenon hier noch einige Möglichkeiten mehr.

  • Wechseln Sie auf die Seite Zeit .
  • Wählen Sie unter Filter Type die Einstellung Zeit-Tag.

Mit dieser Einstellung wird Ihnen in der Runtime anstelle des gesamten Filterdialogs nur ein Übersichtskalender angezeigt, aus dem Sie einen einzelnen Tag auswählen können. Ein Tag dauert dabei standardmäßig von 00:00 bis 24:00.

  • Setzen Sie den Offset auf sechs Stunden.

Jetzt dauert unser Tag von 6:00 bis 6:00 am nächsten Tag.

  • Setzen Sie die Länge auf sechzehn Stunden.
  • Belassen Sie die Option Länge abziehen.

Nun dauert der Tag von 6:00 bis 14:00, was genau einer Frühschicht entspricht.

  • Lassen Sie neue Runtime-Dateien erzeugen.
  • Wechseln Sie in die Runtime.
  • Laden Sie die geänderten Runtime-Dateien nach.
  • Klicken Sie auf den Button Archiv.

Der folgende Filterdialog öffnet sich nun.


Erstellen eines Verdichtungsarchivs

Archivserver -> Erstellen eines Verdichtungsarchivs

Wir erstellen nun ein Verdichtungsarchiv zu unserem Basisarchiv.

  • Indem Sie mit der rechten Maustaste auf den Eintrag BA - BASISARCHIV klicken, öffnen Sie ein Kontextmenü.

  • Wählen Sie den Eintrag Verdichtungsarchiv neu.

Folgende Dialogbox öffnet sich.

Noch in diesem Kapitel

Eigenschaften des Verdichtungsarchivs

Laufzeitverhalten des Verdichtungsarchivs

Aufzeichnungsart im Verdichtungsarchiv

Speicherverhalten des Verdichtungsarchivs

Optionen des Verdichtungsarchivs


Eigenschaften des Verdichtungsarchivs

Archivserver -> Erstellen eines Verdichtungsarchivs -> Eigenschaften des Verdichtungsarchivs

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com

  • Tragen Sie die Bezeichnung und den Namen für unser Archiv FA - VERDICHTUNGSARCHIV ein, wie in der obigen Abbildung dargestellt.


Laufzeitverhalten des Verdichtungsarchivs

Archivserver -> Erstellen eines Verdichtungsarchivs -> Laufzeitverhalten des Verdichtungsarchivs

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com

Auf der zweiten Seite der Dialogbox stellen wir nun das Laufzeitverhalten unseres Verdichtungsarchivs ein.

Die Einstellungen entsprechen denen des Basisarchivs.


Aufzeichnungsart im Verdichtungsarchiv

Archivserver -> Erstellen eines Verdichtungsarchivs -> Aufzeichnungsart im Verdichtungsarchiv

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com

Die dritte Seite der Dialogbox erlaubt uns die Einstellung zur Aufzeichnungsart.

Hier sind keine weiteren Einstellungen nötig. Verdichtungsarchive werden immer bei Wertänderung aufgezeichnet. zenon erkennt das Archiv als Verdichtungsarchiv und setzt die Abtastung automatisch auf bei Wertänderung . Die Abtastung ergibt sich aus der Länge der Basisarchiv-Dateien.


Speicherverhalten des Verdichtungsarchivs

Archivserver -> Erstellen eines Verdichtungsarchivs -> Speicherverhalten des Verdichtungsarchivs

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com

Auf der vierten Seite dieser Dialogbox stellen wir nun ein, wie die Archivdateien gespeichert werden sollten.

  • Wir speichern unser Verdichtungsarchiv in der Internen Datenbank (d.h. im zenon Format). So können wir die Archiveinträge später in anderen Modulen (etwa Report Generator oder Erweitertes Trend Modul) weiterverwenden.
  • Stellen Sie den Zyklus auf zehn Minuten. Wir bekommen damit für jeweils zehn Minuten eine eigene Datei.
  • In der Sektion Ringbuffer stellen Sie ein, dass unsere Archive nicht ausgelagert werden sollen. Die Verdichtungsarchivdateien sollen drei Tage aufbewahrt werden.


Optionen des Verdichtungsarchivs

Archivserver -> Erstellen eines Verdichtungsarchivs -> Optionen des Verdichtungsarchivs

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com

Auf der fünften und letzten Seite dieser Dialogbox benötigen wir für unser Beispiel keine Einstellungen. Diese Optionen würden sich nur auf die Berechnung eines weiteren Verdichtungsarchivs auswirken. Ein solches wollen wir aber nicht mehr erstellen.


Das Verdichtungsarchiv in der Runtime

Archivserver -> Das Verdichtungsarchiv in der Runtime

Für unser kleines Beispiel erübrigt es sich eine neue Funktion anzulegen.

  • Starten Sie die Runtime (neu).
  • Öffnen Sie das Archiv-Bild.

Das Bild zeigt jetzt - wie schon beim ersten Runtime-Start - die Einträge des Basisarchivs.

  • Klicken Sie im Archiv-Bild auf den Button Öffnen.

  • Klicken Sie auf das + vor BA - BASISARCHIV.
  • Wählen Sie das Verdichtungsarchiv aus und verlassen Sie die Dialogbox mit OK.

Angehängt an den Variablennamen sehen Sie jetzt auch die Art der Berechnung.

[MA] | Maximum
[MI] | Minimum
[MW] | Mittelwert
[SU] | Summe


Chargenarchivierung

Archivserver -> Chargenarchivierung

Ein Chargenarchiv findet klassischerweise den Einsatz in Anlagen, in denen keine zyklischen Abläufe in der Produktion gegeben sind. D.h. es gibt keine starr vordefinierten Zeitabläufe in der Produktion. Als Beispiel wäre eine Getränke-Abfüllanlage anzuführen (Unterschiedliche Produkte, unterschiedliche Produktionsmengen und somit Zeiten).

Ein Chargenarchiv zeichnet sich gegenüber einem normalen Archiv durch folgende Punkte aus:

Definierter Start und Stop Zeitpunkt des Archives (Typisch: nicht zyklisch)

Definierter Chargen-Name

Wir erstellen nun ein Chargenarchiv, das die Werte unserer Temperaturfühler für bestimmte Produktionszyklen aufzeichnet. Der Name der jeweiligen Charge soll durch die Variable Chargenname vergeben werden.

  • Legen Sie eine neue String-Variable mit dem Namen Chargenname an (Daten-String, interner Treiber).
  • Setzen Sie die Eigenschaft Interne Variable/Remanenz dieser Variable auf Remanent.
  • Setzen Sie die Eigenschaft Adressierung/Stringlänge auf 20.

Damit merkt sich zenon den letzten Wert dieser Variable, auch wenn die Runtime beendet wird.

  • Indem Sie mit der rechten Maustaste auf den Eintrag Archivierung klicken, öffnen Sie ein Kontextmenü.

  • Wählen Sie den Eintrag Archiv neu.

Folgende Dialogbox öffnet sich.

Noch in diesem Kapitel

Eigenschaften des Chargenarchivs

Laufzeitverhalten des Chargenarchivs

Abtastung im Chargenarchiv

Speicherverhalten des Chargenarchivs

Optionen des Chargenarchivs

Die Chargenfilter


Eigenschaften des Chargenarchivs

Archivserver -> Chargenarchivierung -> Eigenschaften des Chargenarchivs

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com

  • Tragen Sie die Bezeichnung und den Namen für unser Archiv CA - CHARGENARCHIV ein, wie in der obigen Abbildung dargestellt.
  • Über den Button ... neben dem Eintrag Chargenvariable gelangen Sie in die Variablenliste. Dort wählen Sie die Variable Chargenname aus und verlassen die Variablenliste mit OK.
  • Über das Kontext-Menü im Bereich Verknüpfte Variablen und den Befehl Variable hinzufügen gelangen Sie in die Variablenliste.
  • Wählen Sie die Variablen Temp[1,1], Temp[1,2], Temp[2,1] und Temp[2,2] aus und verlassen Sie die Variablenliste mit OK.

So sollte die Dialogbox nun aussehen, nachdem Sie die Variablenliste durch einen Klick auf das + davor geöffnet haben.


Laufzeitverhalten des Chargenarchivs

Archivserver -> Chargenarchivierung -> Laufzeitverhalten des Chargenarchivs

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com

Auf der zweiten Seite der Dialogbox stellen wir nun das Laufzeitverhalten unseres Chargenarchivs ein.

  • Setzen Sie Starten und Beenden auf Benutzerdefiniert, damit können wir das Chargenarchiv beim Start und beim Ende des Produktionszyklus manuell (d.h. über Funktionen) ein- und ausschalten.


Abtastung im Chargenarchiv

Archivserver -> Chargenarchivierung -> Abtastung im Chargenarchiv

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com

Die dritte Seite der Dialogbox erlaubt die Einstellung zur Abtastung.


Speicherverhalten des Chargenarchivs

Archivserver -> Chargenarchivierung -> Speicherverhalten des Chargenarchivs

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com

Auf der vierten Seite dieser Dialogbox stellen wir nun ein, wie die Archivdateien gespeichert werden sollten.

  • Wir speichern unser Chargenarchiv in der Internen Datenbank (d.h. im zenon Format). So können wir die Archiveinträge später in anderen Modulen (etwa Report Generator oder Erweitertes Trend Modul ) weiterverwenden.
  • In der Sektion Auslagerung stellen Sie ein, dass unsere Archive nicht ausgelagert werden sollen. Die Chargenarchivdateien sollen fünf Stunden aufbewahrt werden.

Eine Einstellung in der Sektion Zyklus ist nicht nötig, da das Starten und Beenden der Archivdateien von Hand (d.h. über Funktionen) gesteuert wird. Daher wird dieser Wert auch ignoriert, sofern die Länge der Dateien betroffen ist.

Allerdings hat dieser Wert Einfluss darauf, wie viele Archivdateien aufbewahrt werden sollen. Die unterschiedliche tatsächliche Länge unserer Archivdateien wird nämlich hier gar nicht berücksichtigt. Tatsächlich rechnet sich zenon die Anzahl der aufzubewahrenden Archivdateien folgendermaßen aus:

5 Stunden (Archive aufbewahren) / 15 Minuten (Zyklus) = 20 aufzubewahrende Dateien.


Optionen des Chargenarchivs

Archivserver -> Chargenarchivierung -> Optionen des Chargenarchivs

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com

Auf der fünften und letzten Seite dieser Dialogbox benötigen wir für unser Beispiel keine Einstellungen. Diese Optionen würden sich nur auf die Berechnung eines Verdichtungsarchivs auswirken. Ein solches wollen wir aber nicht mehr erstellen.


Die Chargenfilter

Archivserver -> Chargenarchivierung -> Die Chargenfilter

Die Chargenfilter werden - wie wir es schon bei den anderen Filter-Möglichkeiten der Archivierung gesehen haben - über die Bildumschaltung-Funktion definiert.

  • Wählen Sie für diesen Button in der Funktionsverwaltung die Funktion Bildumschaltung und dann das Bild Archiv.
  • Wählen Sie das Archiv CA - CHARGENARCHIV aus.
  • Betätigen Sie jetzt den Button Filter.

Neben den ersten beiden Seiten dieses Filter-Dialogs, die wir ja schon kennen, steht noch eine dritte Seite speziell für den Zugriff auf Chargenarchive zur Verfügung.

  • Aktivieren Sie die Option Filtern auf Chargen aktiv.

Jetzt bietet uns dieser Dialog drei Möglichkeiten auf bestimmte Chargen zu filtern.

Charge | Hier können Sie einen oder mehrere Chargennamen direkt eingeben. Als Trennzeichen wird | verwendet. Bei den einzelnen Chargennamen sind Platzhalter (* oder ?) erlaubt.
Letzte abgeschlossene Chargen | Hier können Sie die Anzahl der letzten abgeschlossenen Chargen angeben, die angezeigt werden sollen.
Zeitgrenzen | Mit dieser Einstellung definieren Sie, wie sich Ihre Chargen in Bezug auf einen eingestellten Zeitfilter verhalten sollen.
  • Aktivieren Sie die Option Letzte abgeschlossene Chargen und belassen Sie die Anzahl bei 1.
  • Schließen Sie den Dialog mit OK.
  • Öffnen Sie das Bild BL-Start und fügen Sie einen neuen Button mit der Beschriftung Chargen hinzu.


Chargenarchive in der Runtime

Archivserver -> Chargenarchive in der Runtime

Noch in diesem Kapitel

Vorbereitungen

Die Chargen in der Runtime


Vorbereitungen

Archivserver -> Chargenarchive in der Runtime -> Vorbereitungen

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com

Bevor wir die Chargenarchivierung in der Runtime ausprobieren können, benötigen wir noch einige Vorbereitungen. Um verschiedene Chargen anlegen zu können, müssen wir das Chargenarchiv starten und beenden können. Normalerweise geschieht dies über eine Variable aus der Steuerung. Wenn z. B. Schichten als Chargen abgebildet werden, so kann dies auch zeitgesteuert geschehen. In unserem Beispiel werden wir dies von Hand tun.

  • Legen Sie eine neue Funktion Archiv starten aus den Archiv - Funktionen an.
  • Als Parameter wählen Sie CA - CHARGENARCHIV.
  • Schließen Sie den Dialog mit OK.
  • Legen Sie eine neue Funktion Archiv beenden aus den Archiv - Funktionen an.
  • Als Parameter wählen Sie wieder CA - CHARGENARCHIV.
  • Schließen Sie den Dialog mit OK.

Nachdem wir nun die Funktionen zum Steuern der Chargenaufzeichnung haben, müssen wir noch Buttons für diese Funktionen anlegen.

  • Öffnen Sie im Editor das Startbild.
  • Fügen Sie zwei Textbuttons ein und geben Sie ihnen eine entsprechende Beschriftung.
  • Verknüpfen Sie die Buttons mit den neuen Funktionen.
  • Fügen Sie ein neues Element Text verknüpfen ein und verknüpfen Sie es mit der Variable Chargenname.
  • Setzen Sie die Eigenschaft Sollwert setzen/Sollwert setzen über auf Element.


Die Chargen in der Runtime

Archivserver -> Chargenarchive in der Runtime -> Die Chargen in der Runtime

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com
  • Starten Sie die Runtime oder laden Sie die Änderungen nach.
  • Starten Sie das Chargenarchiv mit dem entsprechenden Button auf dem Startbild.
  • Tragen Sie als Chargennamen Charge 1 ein.

Wann immer das Archiv beendet wird, liest zenon den Inhalt dieser Variable und weist ihn der Charge als Namen zu.

  • Beenden Sie das Chargenarchiv mit dem entsprechenden Button auf dem Startbild.
  • Wechseln Sie mit dem Button Chargen auf das Archiv-Bild.


Auslagerung in SQL-Datenbank

Archivserver -> Auslagerung in SQL-Datenbank

Oft ist es erforderlich, in zenon archivierte Daten in Fremdapplikationen weiterverarbeiten zu können. Manchmal ist auch nur ein standardisiertes Ablageverfahren der Daten vorgeschrieben. Zu diesem Zweck bietet zenon die Möglichkeit, Archivdaten in einer SQL-Datenbank abzulegen. Dieses Verfahren ist mit der schon beschriebenen Auslagerung in dBase- oder Textdateien vergleichbar, hat jedoch den Vorteil, dass diese Archivdaten auch nach der Auslagerung noch in zenon für Trends und Reports zur Verfügung stehen.

Noch in diesem Kapitel

Funktionsweise

Projektierung

Datenbank Struktur

Anbindung an Oracle Datenbank System


Funktionsweise

Archivserver -> Auslagerung in SQL-Datenbank -> Funktionsweise

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com

Aus Performancegründen werden für die Ablage der Archivdaten in einer SQL-Datenbank zwei Stadien der Datenhaltung unterschieden. Die Kurzzeitdaten (gem. Einstellung Archive aufbewahren im Dialog Speichern) werden wie gehabt im ARX-Format auf dem lokalen Datenträger gespeichert. Ist die eingestellte Ringbuffer-Lebenszeit der Archivdatei erreicht, so wird der Inhalt dieser Datei als gesammelte Transaktion in die SQL-Datenbank geschrieben und lokal gelöscht. Werden nun Daten dieses Archivs für Trend oder Report benötigt, so werden die lokal abgelegten Kurzzeitdaten mit den in der SQL-Datenbank abgelegten zenon Langzeitdaten automatisch wieder zu einem nahtlosen Datenstrom kombiniert.


Projektierung

Archivserver -> Auslagerung in SQL-Datenbank -> Projektierung

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com

Um die Daten eines Archivs in einer SQL-Datenbank abzulegen, ist im Dialog Speichern die Ringbuffereinstellung SQL-Datenbank zu wählen und die gewünschte OLE-DB Datenquelle zu selektieren.

Zur Wahl der OLE-DB Datenquelle wird der entsprechende Standarddialog verwendet.


Datenbank Struktur

Archivserver -> Auslagerung in SQL-Datenbank -> Datenbank Struktur

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com

Für jedes Archiv wird in der Datenbank eine Tabelle angelegt, welche die ausgelagerten Archivdaten beinhalten wird. Zusätzlich wird für das gesamte Projekt eine Querverweistabelle erzeugt, welche eine Zuordnung zwischen Variablennamen und eindeutiger numerischer Variablen-ID beinhaltet.

Noch in diesem Kapitel

Format der Datentabelle

Format der Querverweistabelle


Format der Datentabelle

Archivserver -> Auslagerung in SQL-Datenbank -> Datenbank Struktur -> Format der Datentabelle

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com

Format der Datenbanktabelle: Projektname_Kurzbezeichnung

Spalte

Typ

Bedeutung

VARIABLE

int[4]

numerische Variablen-ID

CALCULATION

int[4]

Verdichtungsart bei Verdichtungsarchiven.

Bis zu 4 Werte sind möglich: Summe, Mittelwert, Minimum, Maximum.
Beim Export des Verdichtungsarchivs in eine Datei (zum Beispiel .csv) werden die Werte 1 bis 4 als Strings geschrieben:

  • 1=Summe
  • 2=Mittelwert
  • 3=Minimum
  • 4=Maximum

Bei Auslagerung oder Export nach SQL werden die Werte im ASCII-Code als Integer geschrieben:

  • 49=Summe
  • 50=Mittelwert
  • 51=Minimum
  • 52=Maximum

TIMESTAMP_S

int[4]

Zeitstempel in UNIX-Zeitformat

TIMESTAMP_MS

int[4]

Millisekundenanteil des Zeitstempels

VALUE

float[8]

Wert

STATUS

int[4]

Statusflags zum Wert (zenon Status)

GUID

char[36]

Nimmt die Projekt-Guid der Variable aus einem fremden Projekt auf oder ist NULL wenn die Variable aus dem eigenen Projekt.

STRVALUE

varchar

Die Länge hängt von der längsten zu archivierenden Stringvariable ab. Bei einer numerischen Variable hat das Feld den Wert NULL.

Der Name der Datenbanktabelle Projektname_VARIABLES setzt sich aus dem Projektnamen und der Archiv-Kurzbezeichnung zusammen. Beide Teile werden mit dem Unterstreichungszeichen verbunden. Ist der Projektname also ARV_IN_DB und die Archivkurzbezeichnung A1, so lautet der Tabellenname ARV_IN_DB_A1.


Format der Querverweistabelle

Archivserver -> Auslagerung in SQL-Datenbank -> Datenbank Struktur -> Format der Querverweistabelle

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com
Spalte | Typ | Bedeutung
VARIABLE | int[4] | numerische Variablen-ID
NAME | varchar[128] | Name der Variable

Der Name der Querverweistabelle setzt sich aus dem Projektnamen und der Endung VARIABLES zusammen. Beide Teile werden mit dem Unterstreichungszeichen verbunden. Ist der Projektname also ARV_IN_DB, so lautet der Tabellenname ARV_IN_DB_VARIABLES.


Anbindung an Oracle Datenbank System

Archivserver -> Auslagerung in SQL-Datenbank -> Anbindung an Oracle Datenbank System

Vorheriges Kapitel Nächstes Kapitel Alle anzeigen Alle anzeigen Alle verbergen Alle verbergen
© Ing. Punzenberger COPA-DATA GmbH. Sollten Sie Fragen oder Anregungen zur Dokumentation haben, wenden Sie sich bitte an: documentation@copadata.com

Prinzipiell ist die Auslagerung auf eine Oracledatenbank möglich, allerdings sollten ein paar Punkte beachtet werden.

attention Achtung

Möchte man direkt von zenon die Tablellen auf dem SQL Server erstellen lassen, so muss der anzumeldende Benutzer Rechte für CREATE Table besitzen. Sind diese nicht vorhanden, können die Tabellen nicht automatisch erstellt werden.

attention Achtung

Auf der Querverweistabelle muss für den Benutzer das INSERT, DELETE und das SELECT Statement ausführbar sein (UPDATE wird nicht verwendet; DELETE wird nur verwendet, wenn Variablen hinzugefügt oder weggenommen werden).

attention Achtung

Auf der Oracle Seite muss ein ODBC Oracle Client vorhanden sein. Aus Erfahrung können wir sagen, dass es von Vorteil ist, dass die Versionsnummern am Oracle Server und am Client nur gering voneinander abweichen, da sonst ungewollte Effekte mit den Formaten auftreten können.

attention Achtung

Das Zeitformat von zenon ist in GMT ab 1970 (DWORD). Allerdings verwendet Oracle einen anderen Timestamp und dieser muss mit einem Trigger auf Oracle Seite umgewandelt werden.